Index: code/branches/cpp11_v3/src/libraries/tools/IcoSphere.cc
===================================================================
--- code/branches/cpp11_v3/src/libraries/tools/IcoSphere.cc	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/tools/IcoSphere.cc	(revision 11054)
@@ -116,7 +116,6 @@
             std::list<TriangleIndices> faces2;
 
-            for (std::list<TriangleIndices>::iterator j = faces.begin(); j != faces.end(); j++)
+            for (const TriangleIndices& f : faces)
             {
-                TriangleIndices f = *j;
                 int a = getMiddlePoint(f.v1, f.v2);
                 int b = getMiddlePoint(f.v2, f.v3);
@@ -127,8 +126,8 @@
                 removeLineIndices(f.v3, f.v1);
 
-                faces2.push_back(TriangleIndices(f.v1, a, c));
-                faces2.push_back(TriangleIndices(f.v2, b, a));
-                faces2.push_back(TriangleIndices(f.v3, c, b));
-                faces2.push_back(TriangleIndices(a, b, c));
+                faces2.emplace_back(f.v1, a, c);
+                faces2.emplace_back(f.v2, b, a);
+                faces2.emplace_back(f.v3, c, b);
+                faces2.emplace_back(a, b, c);
 
                 addTriangleLines(f.v1, a, c);
@@ -143,5 +142,5 @@
     void IcoSphere::addLineIndices(int index0, int index1)
     {
-        lineIndices.push_back(LineIndices(index0, index1));
+        lineIndices.emplace_back(index0, index1);
     }
 
@@ -164,5 +163,5 @@
     {
         Ogre::Real length = vertex.length();
-        vertices.push_back(Ogre::Vector3(vertex.x / length, vertex.y / length, vertex.z / length));
+        vertices.emplace_back(vertex.x / length, vertex.y / length, vertex.z / length);
         return index++;
     }
@@ -189,13 +188,13 @@
     void IcoSphere::addFace(int index0, int index1, int index2)
     {
-        faces.push_back(TriangleIndices(index0, index1, index2));
+        faces.emplace_back(index0, index1, index2);
     }
 
     void IcoSphere::addToLineIndices(int baseIndex, std::list<int>* target) const
     {
-        for (std::list<LineIndices>::const_iterator i = lineIndices.begin(); i != lineIndices.end(); i++)
+        for (const LineIndices& line : lineIndices)
         {
-            target->push_back(baseIndex + (*i).v1);
-            target->push_back(baseIndex + (*i).v2);
+            target->push_back(baseIndex + line.v1);
+            target->push_back(baseIndex + line.v2);
         }
     }
@@ -203,9 +202,9 @@
     void IcoSphere::addToTriangleIndices(int baseIndex, std::list<int>* target) const
     {
-        for (std::list<TriangleIndices>::const_iterator i = faces.begin(); i != faces.end(); i++)
+        for (const TriangleIndices& triangle : faces)
         {
-            target->push_back(baseIndex + (*i).v1);
-            target->push_back(baseIndex + (*i).v2);
-            target->push_back(baseIndex + (*i).v3);
+            target->push_back(baseIndex + triangle.v1);
+            target->push_back(baseIndex + triangle.v2);
+            target->push_back(baseIndex + triangle.v3);
         }
     }
@@ -217,6 +216,6 @@
         transform.setScale(Ogre::Vector3(scale, scale, scale));
 
-        for (int i = 0; i < (int) vertices.size(); i++)
-            target->push_back(VertexPair(transform * vertices[i], colour));
+        for (const Ogre::Vector3& vertex : vertices)
+            target->emplace_back(transform * vertex, colour);
 
         return vertices.size();
Index: code/branches/cpp11_v3/src/libraries/tools/Mesh.cc
===================================================================
--- code/branches/cpp11_v3/src/libraries/tools/Mesh.cc	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/tools/Mesh.cc	(revision 11054)
@@ -44,5 +44,5 @@
     Mesh::Mesh()
     {
-        this->entity_ = 0;
+        this->entity_ = nullptr;
         this->bCastShadows_ = true;
     }
@@ -73,5 +73,5 @@
             {
                 orxout(internal_error) << "Couldn't load mesh \"" << meshsource << '"' << endl;
-                this->entity_ = 0;
+                this->entity_ = nullptr;
             }
         }
Index: code/branches/cpp11_v3/src/libraries/tools/OgreBulletUtils.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/tools/OgreBulletUtils.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/tools/OgreBulletUtils.h	(revision 11054)
@@ -10,4 +10,9 @@
 
 #include "tools/ToolsPrereqs.h"
+#include <OgreVector3.h>
+#include <OgreQuaternion.h>
+#include <OgreColourValue.h>
+#include <OgreMatrix3.h>
+#include <OgreMatrix4.h>
 
 namespace orxonox
@@ -42,5 +47,5 @@
     inline Ogre::Matrix3 matrix3(const btMatrix3x3& matrix)
     {
-        return Matrix3(
+        return Ogre::Matrix3(
                 matrix[0][0], matrix[0][1], matrix[0][2],
                 matrix[1][0], matrix[1][1], matrix[1][2],
Index: code/branches/cpp11_v3/src/libraries/tools/ParticleInterface.cc
===================================================================
--- code/branches/cpp11_v3/src/libraries/tools/ParticleInterface.cc	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/tools/ParticleInterface.cc	(revision 11054)
@@ -59,5 +59,5 @@
 
         this->scenemanager_ = scenemanager;
-        this->particleSystem_ = 0;
+        this->particleSystem_ = nullptr;
 
         this->bEnabled_ = true;
@@ -80,5 +80,5 @@
             {
                 orxout(internal_error) << "Couldn't load particle system \"" << templateName << '"' << endl;
-                this->particleSystem_ = 0;
+                this->particleSystem_ = nullptr;
             }
         }
@@ -110,5 +110,5 @@
         }
         else
-            return 0;
+            return nullptr;
     }
     Ogre::ParticleEmitter* ParticleInterface::getEmitter(unsigned int emitterNr) const
@@ -117,5 +117,5 @@
             return this->particleSystem_->getEmitter(emitterNr);
         else
-            return 0;
+            return nullptr;
     }
     void ParticleInterface::removeEmitter(unsigned int emitterNr)
@@ -142,5 +142,5 @@
             return this->particleSystem_->addAffector(name);
         else
-            return 0;
+            return nullptr;
     }
     Ogre::ParticleAffector* ParticleInterface::getAffector(unsigned int affectorNr)
@@ -149,5 +149,5 @@
             return this->particleSystem_->getAffector(affectorNr);
         else
-            return 0;
+            return nullptr;
     }
     void ParticleInterface::removeAffector(unsigned int affectorNr)
Index: code/branches/cpp11_v3/src/libraries/tools/ParticleInterface.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/tools/ParticleInterface.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/tools/ParticleInterface.h	(revision 11054)
@@ -78,5 +78,5 @@
 
         protected:
-            virtual void changedTimeFactor(float factor_new, float factor_old);
+            virtual void changedTimeFactor(float factor_new, float factor_old) override;
 
         private:
Index: code/branches/cpp11_v3/src/libraries/tools/ResourceCollection.cc
===================================================================
--- code/branches/cpp11_v3/src/libraries/tools/ResourceCollection.cc	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/tools/ResourceCollection.cc	(revision 11054)
@@ -48,8 +48,4 @@
     }
 
-    ResourceCollection::~ResourceCollection()
-    {
-    }
-
     void ResourceCollection::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
@@ -93,5 +89,5 @@
     {
         if (index >= resourceLocations_.size())
-            return NULL;
+            return nullptr;
         else
             return resourceLocations_[index];
Index: code/branches/cpp11_v3/src/libraries/tools/ResourceCollection.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/tools/ResourceCollection.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/tools/ResourceCollection.h	(revision 11054)
@@ -42,7 +42,7 @@
     public:
         ResourceCollection(Context* context);
-        virtual ~ResourceCollection();
+        virtual ~ResourceCollection() = default;
 
-        virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+        virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
 
         void setResourceGroup(const std::string& resourceGroup);
@@ -54,5 +54,7 @@
 
     private:
-        ResourceCollection(const ResourceCollection&);
+        // non-copyable:
+        ResourceCollection(const ResourceCollection&) = delete;
+        ResourceCollection& operator=(const ResourceCollection&) = delete;
 
         std::string resourceGroup_;
Index: code/branches/cpp11_v3/src/libraries/tools/ResourceLocation.cc
===================================================================
--- code/branches/cpp11_v3/src/libraries/tools/ResourceLocation.cc	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/tools/ResourceLocation.cc	(revision 11054)
@@ -54,8 +54,4 @@
     }
 
-    ResourceLocation::~ResourceLocation()
-    {
-    }
-
     void ResourceLocation::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
Index: code/branches/cpp11_v3/src/libraries/tools/ResourceLocation.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/tools/ResourceLocation.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/tools/ResourceLocation.h	(revision 11054)
@@ -44,7 +44,7 @@
     public:
         ResourceLocation(Context* context);
-        virtual ~ResourceLocation();
+        virtual ~ResourceLocation() = default;
 
-        virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+        virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
 
         void setPath(const std::string& path) { path_ = path; }
@@ -60,5 +60,7 @@
 
     private:
-        ResourceLocation(const ResourceLocation&);
+        // non-copyable:
+        ResourceLocation(const ResourceLocation&) = delete;
+        ResourceLocation& operator=(const ResourceLocation&) = delete;
 
         void load(const std::string& resourceGroup);
Index: code/branches/cpp11_v3/src/libraries/tools/Shader.cc
===================================================================
--- code/branches/cpp11_v3/src/libraries/tools/Shader.cc	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/tools/Shader.cc	(revision 11054)
@@ -44,5 +44,5 @@
         @brief Initializes the values and sets the scene manager.
     */
-    Shader::Shader(Ogre::SceneManager* scenemanager) : compositorInstance_(0)
+    Shader::Shader(Ogre::SceneManager* scenemanager) : compositorInstance_(nullptr)
     {
         RegisterObject(Shader);
@@ -109,5 +109,5 @@
     {
         // For the moment, we get the viewport always from the graphics manager
-        // TODO: Try to support multiple viewports - note however that scenemanager_->getCurrentViewport() returns NULL
+        // TODO: Try to support multiple viewports - note however that scenemanager_->getCurrentViewport() returns nullptr
         //       after switching to a camera in a different scene (only for the first time this scene is displayed though)
         this->changedCompositorName(GraphicsManager::getInstance().getViewport());
@@ -127,5 +127,5 @@
                 Ogre::CompositorManager::getSingleton().removeCompositor(viewport, this->oldcompositorName_);
                 this->compositorInstance_->removeListener(this);
-                this->compositorInstance_ = 0;
+                this->compositorInstance_ = nullptr;
             }
             if (!this->compositorName_.empty())
@@ -197,23 +197,23 @@
     {
         // iterate through the list of parameters
-        for (std::list<ParameterContainer>::iterator it = this->parameters_.begin(); it != this->parameters_.end(); ++it)
-        {
-            Ogre::Technique* techniquePtr = materialPtr->getTechnique(it->technique_);
+        for (const ParameterContainer& parameter : this->parameters_)
+        {
+            Ogre::Technique* techniquePtr = materialPtr->getTechnique(parameter.technique_);
             if (techniquePtr)
             {
-                Ogre::Pass* passPtr = techniquePtr->getPass(it->pass_);
+                Ogre::Pass* passPtr = techniquePtr->getPass(parameter.pass_);
                 if (passPtr)
                 {
                     // change the value of the parameter depending on its type
-                    if (it->value_.isType<int>())
-                        passPtr->getFragmentProgramParameters()->setNamedConstant(it->parameter_, it->value_.get<int>());
-                    else if (it->value_.isType<float>())
-                        passPtr->getFragmentProgramParameters()->setNamedConstant(it->parameter_, it->value_.get<float>());
+                    if (parameter.value_.isType<int>())
+                        passPtr->getFragmentProgramParameters()->setNamedConstant(parameter.parameter_, parameter.value_.get<int>());
+                    else if (parameter.value_.isType<float>())
+                        passPtr->getFragmentProgramParameters()->setNamedConstant(parameter.parameter_, parameter.value_.get<float>());
                 }
                 else
-                    orxout(internal_warning) << "No pass " << it->pass_ << " in technique " << it->technique_ << " in compositor \"" << this->compositorName_ << "\" or pass has no shader." << endl;
+                    orxout(internal_warning) << "No pass " << parameter.pass_ << " in technique " << parameter.technique_ << " in compositor \"" << this->compositorName_ << "\" or pass has no shader." << endl;
             }
             else
-                orxout(internal_warning) << "No technique " << it->technique_ << " in compositor \"" << this->compositorName_ << "\" or technique has no pass with shader." << endl;
+                orxout(internal_warning) << "No technique " << parameter.technique_ << " in compositor \"" << this->compositorName_ << "\" or technique has no pass with shader." << endl;
         }
         this->parameters_.clear();
@@ -228,6 +228,6 @@
         {
             const Ogre::Root::PluginInstanceList& plugins = Ogre::Root::getSingleton().getInstalledPlugins();
-            for (size_t i = 0; i < plugins.size(); ++i)
-                if (plugins[i]->getName() == "Cg Program Manager")
+            for (Ogre::Plugin* plugin : plugins)
+                if (plugin->getName() == "Cg Program Manager")
                     return true;
         }
Index: code/branches/cpp11_v3/src/libraries/tools/Shader.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/tools/Shader.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/tools/Shader.h	(revision 11054)
@@ -48,5 +48,5 @@
     {
         public:
-            Shader(Ogre::SceneManager* scenemanager = 0);
+            Shader(Ogre::SceneManager* scenemanager = nullptr);
             virtual ~Shader();
 
@@ -87,10 +87,10 @@
                 { return this->scenemanager_; }
 
-            virtual void cameraChanged(Ogre::Viewport* viewport, Ogre::Camera* oldCamera);
+            virtual void cameraChanged(Ogre::Viewport* viewport, Ogre::Camera* oldCamera) override;
 
             void setParameter(unsigned short technique, unsigned short pass, const std::string& parameter, float value);
             void setParameter(unsigned short technique, unsigned short pass, const std::string& parameter, int value);
 
-            virtual void notifyMaterialRender(Ogre::uint32 pass_id, Ogre::MaterialPtr& materialPtr);
+            virtual void notifyMaterialRender(Ogre::uint32 pass_id, Ogre::MaterialPtr& materialPtr) override;
 
         private:
Index: code/branches/cpp11_v3/src/libraries/tools/TextureGenerator.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/tools/TextureGenerator.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/tools/TextureGenerator.h	(revision 11054)
@@ -49,9 +49,11 @@
 
     private:
-        TextureGenerator();
-        TextureGenerator(const TextureGenerator&);
-        ~TextureGenerator();
+        // static class, no instances allowed:
+        TextureGenerator() = delete;
+        TextureGenerator(const TextureGenerator&) = delete;
+        TextureGenerator& operator=(const TextureGenerator&) = delete;
+        ~TextureGenerator() = delete;
 
-        static std::map<std::string, std::map<ColourValue, std::string> > materials_s;
+        static std::map<std::string, std::map<ColourValue, std::string>> materials_s;
         static unsigned int materialCount_s;
     };
Index: code/branches/cpp11_v3/src/libraries/tools/Timer.cc
===================================================================
--- code/branches/cpp11_v3/src/libraries/tools/Timer.cc	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/tools/Timer.cc	(revision 11054)
@@ -163,5 +163,5 @@
     void Timer::init()
     {
-        this->executor_ = 0;
+        this->executor_ = nullptr;
         this->interval_ = 0;
         this->bLoop_ = false;
Index: code/branches/cpp11_v3/src/libraries/tools/Timer.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/tools/Timer.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/tools/Timer.h	(revision 11054)
@@ -175,5 +175,5 @@
 
         protected:
-            virtual float getTimeFactor();
+            virtual float getTimeFactor() override;
     };
 }
Index: code/branches/cpp11_v3/src/libraries/tools/interfaces/TimeFactorListener.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/tools/interfaces/TimeFactorListener.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/tools/interfaces/TimeFactorListener.h	(revision 11054)
@@ -39,5 +39,5 @@
         public:
             TimeFactorListener();
-            virtual ~TimeFactorListener() {}
+            virtual ~TimeFactorListener() = default;
 
             static void setTimeFactor(float factor);
Index: code/branches/cpp11_v3/src/libraries/tools/interfaces/ToolsInterfaceCompilation.cc
===================================================================
--- code/branches/cpp11_v3/src/libraries/tools/interfaces/ToolsInterfaceCompilation.cc	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/tools/interfaces/ToolsInterfaceCompilation.cc	(revision 11054)
@@ -60,6 +60,6 @@
         float oldFactor = TimeFactorListener::timefactor_s;
         TimeFactorListener::timefactor_s = factor;
-        for (ObjectList<TimeFactorListener>::iterator it = ObjectList<TimeFactorListener>::begin(); it != ObjectList<TimeFactorListener>::end(); ++it)
-            it->changedTimeFactor(factor, oldFactor);
+        for (TimeFactorListener* listener : ObjectList<TimeFactorListener>())
+            listener->changedTimeFactor(factor, oldFactor);
     }
 
Index: code/branches/cpp11_v3/src/libraries/util/CMakeLists.txt
===================================================================
--- code/branches/cpp11_v3/src/libraries/util/CMakeLists.txt	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/util/CMakeLists.txt	(revision 11054)
@@ -26,5 +26,4 @@
   CRC32.cc
   ExprParser.cc
-  SharedPtr.cc
   Sleep.cc
   SmallObjectAllocator.cc
Index: code/branches/cpp11_v3/src/libraries/util/Clipboard.cc
===================================================================
--- code/branches/cpp11_v3/src/libraries/util/Clipboard.cc	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/util/Clipboard.cc	(revision 11054)
@@ -93,5 +93,5 @@
             {
                 HANDLE hData = GetClipboardData(CF_TEXT);
-                if (hData == NULL)
+                if (hData == nullptr)
                     return "";
                 std::string output(static_cast<char*>(GlobalLock(hData)));
Index: code/branches/cpp11_v3/src/libraries/util/Clock.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/util/Clock.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/util/Clock.h	(revision 11054)
@@ -102,6 +102,7 @@
 
     private:
-        /// Undefined
-        Clock(const Clock& instance);
+        // non-copyable:
+        Clock(const Clock&) = delete;
+        Clock& operator=(const Clock&) = delete;
 
         Ogre::Timer*       timer_;       ///< Ogre timer object
Index: code/branches/cpp11_v3/src/libraries/util/DestructionHelper.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/util/DestructionHelper.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/util/DestructionHelper.h	(revision 11054)
@@ -36,5 +36,5 @@
     /** Deletes an object and resets the pointer
     @param object
-        Pointer to an object. Handing over NULL is safe.
+        Pointer to an object. Handing over nullptr is safe.
     */
     template <class T>
@@ -42,5 +42,5 @@
     {
         delete *object;
-        *object = NULL;
+        *object = nullptr;
     }
 
@@ -87,5 +87,7 @@
 
     private:
-        DestructionHelper(const DestructionHelper&); //!< Don't use (undefined)
+        // non-copyable:
+        DestructionHelper(const DestructionHelper&) = delete;
+        DestructionHelper& operator=(const DestructionHelper&) = delete;
 
         T* object_;
Index: code/branches/cpp11_v3/src/libraries/util/DisplayStringConversions.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/util/DisplayStringConversions.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/util/DisplayStringConversions.h	(revision 11054)
@@ -51,7 +51,7 @@
             {
                 Ogre::UTFString::code_point cp;
-                for (unsigned int i = 0; i < input.size(); ++i)
+                for (const char& character : input)
                 {
-                  cp = input[i];
+                  cp = character;
                   cp &= 0xFF;
                   output->append(1, cp);
Index: code/branches/cpp11_v3/src/libraries/util/ExprParser.cc
===================================================================
--- code/branches/cpp11_v3/src/libraries/util/ExprParser.cc	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/util/ExprParser.cc	(revision 11054)
@@ -391,5 +391,5 @@
     }
 
-    char* ExprParser::parse_word(char* str)
+    void ExprParser::parse_word(char* str)
     {
         char* word = str;
@@ -402,9 +402,8 @@
             {
                 this->failed_ = true;
-                return '\0';
+                return;
             }
         };
         *word = '\0';
-        return str;
     }
 
Index: code/branches/cpp11_v3/src/libraries/util/ExprParser.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/util/ExprParser.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/util/ExprParser.h	(revision 11054)
@@ -139,5 +139,5 @@
         float parse_expr_7();
         float parse_expr_8();
-        char* parse_word(char* str);
+        void parse_word(char* str);
         binary_operator parse_binary_operator();
         unary_operator parse_unary_operator();
Index: code/branches/cpp11_v3/src/libraries/util/ImplicitConversion.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/util/ImplicitConversion.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/util/ImplicitConversion.h	(revision 11054)
@@ -68,5 +68,10 @@
     {
     private:
-        ImplicitConversion(); ImplicitConversion(const ImplicitConversion&); ~ImplicitConversion();
+        // static class, no instances allowed:
+        ImplicitConversion() = delete;
+        ImplicitConversion(const ImplicitConversion&) = delete;
+        ImplicitConversion& operator=(const ImplicitConversion&) = delete;
+        ~ImplicitConversion() = delete;
+
         // Gets chosen only if there is an implicit conversion from FromType to ToType.
         static char test(ToType);
Index: code/branches/cpp11_v3/src/libraries/util/Math.cc
===================================================================
--- code/branches/cpp11_v3/src/libraries/util/Math.cc	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/util/Math.cc	(revision 11054)
@@ -371,4 +371,10 @@
     }
 
+
+    namespace detail
+    {
+        std::mt19937 rngen;
+    }
+
     /**
         @brief Returns a unique number. This function will never return the same value twice.
Index: code/branches/cpp11_v3/src/libraries/util/Math.h
===================================================================
--- code/branches/cpp11_v3/src/libraries/util/Math.h	(revision 11053)
+++ code/branches/cpp11_v3/src/libraries/util/Math.h	(revision 11054)
@@ -46,4 +46,5 @@
 #include <cmath>
 #include <cstdlib>
+#include <random>
 
 #include <OgreMath.h>
@@ -73,11 +74,11 @@
     namespace math
     {
-        const float twoPi   = 6.283185482025146484375f;     ///< PI * 2
-        const float pi      = 3.1415927410125732421875f;    ///< PI
-        const float pi_2    = 1.57079637050628662109375f;   ///< PI / 2
-        const float pi_4    = 0.785398185253143310546875f;  ///< PI / 4
-        const float e       = 2.718281269073486328125f;     ///< e
-        const float sqrt2   = 1.41421353816986083984375f;   ///< sqrt(2)
-        const float sqrt2_2 = 0.707106769084930419921875f;  ///< sqrt(2) / 2
+        constexpr float twoPi   = 6.283185482025146484375f;     ///< PI * 2
+        constexpr float pi      = 3.1415927410125732421875f;    ///< PI
+        constexpr float pi_2    = 1.57079637050628662109375f;   ///< PI / 2
+        constexpr float pi_4    = 0.785398185253143310546875f;  ///< PI / 4
+        constexpr float e       = 2.718281269073486328125f;     ///< e
+        constexpr float sqrt2   = 1.41421353816986083984375f;   ///< sqrt(2)
+        constexpr float sqrt2_2 = 0.707106769084930419921875f;  ///< sqrt(2) / 2
     }
 
@@ -104,5 +105,5 @@
     */
     template <typename T>
-    inline T sgn(T x)
+    constexpr inline T sgn(T x)
     {
         return (x >= 0) ? (T)1 : (T)-1;
@@ -116,13 +117,7 @@
     */
     template <typename T>
-    inline T clamp(T x, T min, T max)
-    {
-        if (x < min)
-            return min;
-
-        if (x > max)
-            return max;
-
-        return x;
+    constexpr inline T clamp(T x, T min, T max)
+    {
+        return x < min ? min : (x > max ? max : x);
     }
 
@@ -131,5 +126,5 @@
     */
     template <typename T>
-    inline T square(T x)
+    constexpr inline T square(T x)
     {
         return x*x;
@@ -140,5 +135,5 @@
     */
     template <typename T>
-    inline T cube(T x)
+    constexpr inline T cube(T x)
     {
         return x*x*x;
@@ -186,8 +181,6 @@
     inline T zeroise()
     {
-        // Default, raise a compiler error without including large boost header cascade.
-        T temp();
-        *********temp; // If you reach this code, you abused zeroise()!
-        return temp;
+        // If you reach this code, you abused zeroise()!
+        static_assert(sizeof(T) != sizeof(T), "No template specialization available for T");
     }
 
@@ -206,5 +199,5 @@
     template <> inline long double          zeroise<long double>()          { return 0; }
     template <> inline bool                 zeroise<bool>()                 { return 0; }
-    template <> inline void*                zeroise<void*>()                { return 0; }
+    template <> inline void*                zeroise<void*>()                { return nullptr; }
     template <> inline std::string          zeroise<std::string>()          { return std::string(); }
     template <> inline orxonox::Radian      zeroise<orxonox::Radian>()      { return orxonox::Radian(0.0f); }
@@ -258,4 +251,31 @@
     }
 
+    namespace detail
+    {
+        /**
+        Random number generator used for the functions below. Marked extern to only have one global instance.
+        */
+        _UtilExport extern std::mt19937 rngen;
+    }
+
+    /**
+    @brief Seeds the random number generator used for the functions below.
+    */
+    inline void rndseed(unsigned int seed)
+    {
+        detail::rngen.seed(seed);
+    }
+
+    /**
+    @brief Returns a random number between @a min and almost @a max: <tt>min <= rnd < max</tt>.
+    @param min The minimum
+    @param max The maximum
+    */
+    inline float rnd(float min, float max)
+    {
+        std::uniform_real_distribution<float> dist(min, max);
+        return dist(detail::rngen);
+    }
+
     /**
         @brief Returns a random number between 0 and almost 1: <tt>0 <= rnd < 1</tt>.
@@ -263,5 +283,5 @@
     inline float rnd()
     {
-        return rand() / (RAND_MAX + 1.0f);
+        return rnd(0, 1);
     }
 
@@ -272,15 +292,5 @@
     inline float rnd(float max)
     {
-        return rnd() * max;
-    }
-
-    /**
-        @brief Returns a random number between @a min and almost @a max: <tt>min <= rnd < max</tt>.
-        @param min The minimum
-        @param max The maximum
-    */
-    inline float rnd(float min, float max)
-    {
-        return rnd(max - min) + min;
+        return rnd(0, max);
     }
 
@@ -290,5 +300,6 @@
     inline float rndsgn()
     {
-        return static_cast<float>((rand() & 0x2) - 1); // rand() & 0x2 is either 2 or 0
+        std::uniform_int_distribution<> dist;
+        return static_cast<float>((dist(detail::rngen) & 0x2) - 1); // dist(...) & 0x2 is either 2 or 0
     }
 
